
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.PriorityQueue;

public class Task15
{
	public static void main(String[] args) throws IOException
	{
		// načítání
		System.setIn(Files.newInputStream(Paths.get("seq.txt")));
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
//		System.setOut(new PrintStream(Files.newOutputStream(Paths.get("task14.out"))));

		TwoHeaps th = new TwoHeaps();

		String line;
		while ((line = br.readLine()) != null)
		{
			if (line.startsWith("insert "))
				System.out.println(Double.toString(th.add(Integer.parseInt(line.substring(7)))));
		}
	}
}

class TwoHeaps
{
	final PriorityQueue<Integer> pq1 = new PriorityQueue<>((Integer o1, Integer o2) -> -Integer.compare(o1, o2));
	final PriorityQueue<Integer> pq2 = new PriorityQueue<>();

	public double add(int i)
	{
		if(pq1.size() + pq2.size() == 0) {
			pq1.add(i);
		    return i;
	    } else if(pq1.size() + pq2.size() == 1) {
			pq2.add(i);
			return ((double) pq1.peek() + (double) pq2.peek()) / 2.0;
		}
		
		if (i <= pq1.peek())
			pq1.add(i);
		else
			pq2.add(i);

		if (pq1.size() == pq2.size() + 2)
		{
			pq2.add(pq1.remove());
			return ((double) pq1.peek() + (double) pq2.peek()) / 2.0;
		}
		else if (pq1.size() == pq2.size() + 1)
			return pq1.peek();
		else if (pq1.size() == pq2.size())
			return ((double) pq1.peek() + (double) pq2.peek()) / 2.0;
		else if (pq1.size() == pq2.size() - 1)
			return pq2.peek();
		else if (pq1.size() == pq2.size() - 2)
		{
			pq1.add(pq2.remove());
			return ((double) pq1.peek() + (double) pq2.peek()) / 2.0;
		}
		else
			throw new RuntimeException();
	}
}
